Subject: Re: [Bugme-new] [Bug 11144] New: dhcp doesn't work with iwl4965

From: François Valenduc<[email-masked]>
Date: Wed, 23 Jul 2008 17:42:04 +0200

Patrick McHardy a écrit :
> Patrick McHardy wrote:
>> François Valenduc wrote:
>>> I did the bisection again, this time on the whole tree and the first 
>>> bad commit is again the one I mentioned previously:
>>>
>>> 175f9c1bba9b825d22b142d183c9e175488b260c is first bad commit
>>> commit 175f9c1bba9b825d22b142d183c9e175488b260c
>>> Author: Jussi Kivilinna <[email-masked]>
>>> Date: Sun Jul 20 00:08:47 2008 -0700
>>>
>>> net_sched: Add size table for qdiscs
>>>
>>> Add size table functions for qdiscs and calculate packet size in
>>> qdisc_enqueue().
>>>
>>> Based on patch by Patrick McHardy
>>> http://marc.info/?l=linux-netdev&m=115201979221729&w=2
>>>
>>> This time, I didn't encounter kernels which didn't compile. So, I 
>>> didn't use git-reset or git-bisect skip.
>>
>>
>> I think I know whats happening (Jussi CCed). That commit introduced
>> a qdisc_skb_cb, which conflicts with the mac80211 usage of skb->cb.
>> mac80211 seems to expect the CB to survive the qdisc layer, which
>> is wrong. One possibility to fix this (or just test my theory)
>> would be to make sure they don't clash by adding the struct
>> ieee80211_tx_info to qdisc_skb_cb->data. Something like this patch.
>>
>
> > +#include <net/sched_generic.h>
>
> That should be sch_generic.h.
>
I tested your last patch. Unfortunately, I get the following compile error:

In file included from net/mac80211/main.c:11:
include/net/mac80211.h: In function ‘IEEE80211_SKB_CB’:
include/net/mac80211.h:347: erreur: size of array ‘type name’ is negative

François